#ifndef BASIC_TIMER_INIT_H
#define BASIC_TIMER_INIT_H

#include <auto-reload.hpp>
#include <counter.hpp>
#include <master-mode-selection.hpp>
#include <one-pulse.hpp>
#include <uev-update.hpp>
#include <update-request-source.hpp>

namespace stm32f072xb {

struct BasicTimerInit {
	TIM_TypeDef* timer;
	const Counter counter;
	const UevUpdate uevUpdate;
	const UpdateRequestSource updateRequestSource;
	const OnePulse onePulse;
	const AutoReload autoReload;
	const MasterModeSelection& masterModeSelection;
	const uint32_t interruptPriority;
};
}  // namespace stm32f072xb

#endif  // BASIC_TIMER_INIT_H
