#include "abstract-gpio.hpp"

using namespace stm32f072xb;

AbstractGpio::AbstractGpio(GPIO_TypeDef* gpio, const AbstractGpioInit& gpioInit) : _gpio(gpio), _gpioInit(gpioInit) {}

AbstractGpio::~AbstractGpio() {
	CLEAR_BIT(_gpio->PUPDR, 3 << (getPin() * 2));
}

uint8_t AbstractGpio::getPin() const {
	return uint8_t(_gpioInit.pin);
}

uint8_t AbstractGpio::getPullMode() const {
	return uint8_t(_gpioInit.pullMode);
}

GPIO_TypeDef* AbstractGpio::getGpio() const {
	return _gpio;
}

void AbstractGpio::setupRegister() const {
	CLEAR_BIT(_gpio->PUPDR, 3 << (getPin() * 2));
	SET_BIT(_gpio->PUPDR, getPullMode() << (getPin() * 2));
}
